unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, D2xxunit;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ComboBox1: TComboBox;
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Button3: TButton;
    Button4: TButton;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    CheckBox2: TCheckBox;
    Edit3: TEdit;
    Edit4: TEdit;
    Button5: TButton;
    Button6: TButton;
    Edit5: TEdit;
    Label7: TLabel;
    GroupBox3: TGroupBox;
    Button7: TButton;
    Button8: TButton;
    GroupBox4: TGroupBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    Button9: TButton;
    procedure ComboBox1DropDown(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Type
  Names = Array[1..20] of string;
  Names_Ptr = ^Names;
  DataBuff = Array[0..63] of byte;
  Data_Ptr = ^DataBuff;

var
  Form1: TForm1;
  PortAIsOpen : boolean;
  My_Names : Names;
  OutIndex : integer;
  Out_Buff : DataBuff;
  In_Buff : DataBuff;
  memolines : integer;

implementation

{$R *.dfm}


procedure List_Devs( My_Names_Ptr : Names_Ptr);
Var res : FT_Result;
NoOfDevs,i,J,k : integer;
Name : String;
done : boolean;
begin
PortAIsOpen := False;
Name := '';
res := GetFTDeviceCount;
if res <> Ft_OK then exit;
NoOfDevs := FT_Device_Count;
j := 0;
k := 1;
if NoOfDevs > 0 then
  begin
    repeat
    res := GetFTDeviceDescription(J);
    if res = Ft_OK then
      begin
      done := false;
      i := 1;
      Name := '';
        repeat
        if ORD(FT_Device_String_Buffer[i]) <> 0 then
          begin
          Name := Name + FT_Device_String_Buffer[i];
          end
        else
          begin
          done := true;
          My_Names_Ptr[k]:= Name;
          k := k + 1;
          end;
        i := i + 1;
        until done;
      end;
    J := J + 1;
    until (J = NoOfDevs);
  end;

end;

function Check_For_Dev_A(Name : string) : boolean;
var len,i : integer;
SubString : string;
begin
Check_For_Dev_A := false;
if (Name <> '') then
  begin
  len := length(Name);
  if (len > 2) then
    begin
    SubString := Name[len-1] + Name[len];
    if (SubString = ' A') then Check_For_Dev_A := true;
    end;
  end;
end;

procedure GetNames;
Var i : integer;
Has_A : boolean;
begin
for i := 1 to 20 do My_Names[i] := '';
Form1.ComboBox1.Clear;
List_Devs(@My_Names);
i := 1;
if (My_Names[i] <> '' ) then
  begin
    repeat
    Has_A := Check_For_Dev_A(My_Names[i]);
    if Has_A then Form1.ComboBox1.Items.Add(My_Names[i]);
    i := i + 1;
    until (My_Names[i] = '');
  end;
end;


function HexWrdToStr(Dval : integer) : string;
var i : integer;
retstr : string;
begin
retstr := '';
i := (Dval AND $F000) DIV $1000;
case i of
  0 : retstr := retstr + '0';
  1 : retstr := retstr + '1';
  2 : retstr := retstr + '2';
  3 : retstr := retstr + '3';
  4 : retstr := retstr + '4';
  5 : retstr := retstr + '5';
  6 : retstr := retstr + '6';
  7 : retstr := retstr + '7';
  8 : retstr := retstr + '8';
  9 : retstr := retstr + '9';
  10 : retstr := retstr + 'A';
  11 : retstr := retstr + 'B';
  12 : retstr := retstr + 'C';
  13 : retstr := retstr + 'D';
  14 : retstr := retstr + 'E';
  15 : retstr := retstr + 'F';
end;
i := (Dval AND $F00) DIV $100;
case i of
  0 : retstr := retstr + '0';
  1 : retstr := retstr + '1';
  2 : retstr := retstr + '2';
  3 : retstr := retstr + '3';
  4 : retstr := retstr + '4';
  5 : retstr := retstr + '5';
  6 : retstr := retstr + '6';
  7 : retstr := retstr + '7';
  8 : retstr := retstr + '8';
  9 : retstr := retstr + '9';
  10 : retstr := retstr + 'A';
  11 : retstr := retstr + 'B';
  12 : retstr := retstr + 'C';
  13 : retstr := retstr + 'D';
  14 : retstr := retstr + 'E';
  15 : retstr := retstr + 'F';
end;
i := (Dval AND $F0) DIV $10;
case i of
  0 : retstr := retstr + '0';
  1 : retstr := retstr + '1';
  2 : retstr := retstr + '2';
  3 : retstr := retstr + '3';
  4 : retstr := retstr + '4';
  5 : retstr := retstr + '5';
  6 : retstr := retstr + '6';
  7 : retstr := retstr + '7';
  8 : retstr := retstr + '8';
  9 : retstr := retstr + '9';
  10 : retstr := retstr + 'A';
  11 : retstr := retstr + 'B';
  12 : retstr := retstr + 'C';
  13 : retstr := retstr + 'D';
  14 : retstr := retstr + 'E';
  15 : retstr := retstr + 'F';
end;
i := Dval AND $F;
case i of
  0 : retstr := retstr + '0';
  1 : retstr := retstr + '1';
  2 : retstr := retstr + '2';
  3 : retstr := retstr + '3';
  4 : retstr := retstr + '4';
  5 : retstr := retstr + '5';
  6 : retstr := retstr + '6';
  7 : retstr := retstr + '7';
  8 : retstr := retstr + '8';
  9 : retstr := retstr + '9';
  10 : retstr := retstr + 'A';
  11 : retstr := retstr + 'B';
  12 : retstr := retstr + 'C';
  13 : retstr := retstr + 'D';
  14 : retstr := retstr + 'E';
  15 : retstr := retstr + 'F';
end;
HexWrdToStr := retstr;
end;

function HexDWrdToStr(Dval : longword) : string;
var i : longword;
tmpstr : string;
begin
i := Dval div $10000;
tmpstr := HexWrdToStr(i);
i := Dval AND $ffff;
tmpstr := tmpstr + HexWrdToStr(i);
HexDWrdToStr := tmpstr;
end;

function HexByteToStr(Dval : integer) : string;
var i : integer;
retstr : string;
begin
retstr := '';
i := (Dval AND $F0) DIV $10;
case i of
  0 : retstr := retstr + '0';
  1 : retstr := retstr + '1';
  2 : retstr := retstr + '2';
  3 : retstr := retstr + '3';
  4 : retstr := retstr + '4';
  5 : retstr := retstr + '5';
  6 : retstr := retstr + '6';
  7 : retstr := retstr + '7';
  8 : retstr := retstr + '8';
  9 : retstr := retstr + '9';
  10 : retstr := retstr + 'A';
  11 : retstr := retstr + 'B';
  12 : retstr := retstr + 'C';
  13 : retstr := retstr + 'D';
  14 : retstr := retstr + 'E';
  15 : retstr := retstr + 'F';
end;
i := Dval AND $F;
case i of
  0 : retstr := retstr + '0';
  1 : retstr := retstr + '1';
  2 : retstr := retstr + '2';
  3 : retstr := retstr + '3';
  4 : retstr := retstr + '4';
  5 : retstr := retstr + '5';
  6 : retstr := retstr + '6';
  7 : retstr := retstr + '7';
  8 : retstr := retstr + '8';
  9 : retstr := retstr + '9';
  10 : retstr := retstr + 'A';
  11 : retstr := retstr + 'B';
  12 : retstr := retstr + 'C';
  13 : retstr := retstr + 'D';
  14 : retstr := retstr + 'E';
  15 : retstr := retstr + 'F';
end;
HexByteToStr := retstr;
end;

function OpenPort(PortName : string) : boolean;
Var res : FT_Result;
NoOfDevs,i,J : integer;
Name : String;
DualName : string;
done : boolean;
begin
PortAIsOpen := False;
OpenPort := False;
Name := '';
Dualname := PortName;
res := GetFTDeviceCount;
if res <> Ft_OK then exit;
NoOfDevs := FT_Device_Count;
j := 0;
if NoOfDevs > 0 then
  begin
    repeat
      repeat
      res := GetFTDeviceDescription(J);
      if (res <> Ft_OK) then  J := J + 1;
      until (res = Ft_OK) OR (J=NoOfDevs);
    if res <> Ft_OK then exit;
    done := false;
    i := 1;
    Name := '';
      repeat
      if ORD(FT_Device_String_Buffer[i]) <> 0 then
        begin
        Name := Name + FT_Device_String_Buffer[i];
        end
      else
        begin
        done := true;
        end;
      i := i + 1;
      until done;
    J := J + 1;
    until (J = NoOfDevs) or (name = DualName);
  end;

if (name = DualName) then
  begin
  res := Open_USB_Device_By_Device_Description(name);
  if res <> Ft_OK then exit;
  OpenPort := true;
  res := Get_USB_Device_QueueStatus;
  if res <> Ft_OK then exit;
  PortAIsOpen := true;
  end
else
  begin
  OpenPort := false;
  end;

end;

procedure ClosePort;
Var res : FT_Result;
begin
if PortAIsOpen then
  res := Close_USB_Device;
PortAIsOpen := False;
end;


procedure SendBytes(NumberOfBytes : integer);
var i : integer;
begin
i := Write_USB_Device_Buffer( NumberOfBytes);
OutIndex := OutIndex - i;
end;


procedure AddToBuffer(I:integer);
begin
FT_Out_Buffer[OutIndex]:= I AND $FF;
inc(OutIndex);
end;


function Sync_To_MPSSE : boolean;
//
// This should satisfy outstanding commands.
//
// We will use $AA and $AB as commands which
// are invalid so that the MPSSE block should echo these
// back to us preceded with an $FA
//
var res : FT_Result;
i,j : integer;
Done : boolean;
begin
Sync_To_MPSSE := false;
res := Get_USB_Device_QueueStatus;
if res <> FT_OK then exit;
if (FT_Q_Bytes > 0) then
  i := Read_USB_Device_Buffer(FT_Q_Bytes);
  repeat
  OutIndex := 0;
  AddToBuffer($AA); // bad command
  SendBytes(OutIndex);
  res := Get_USB_Device_QueueStatus;
  if FT_Q_Bytes = 0 then sleep(0);
  until (FT_Q_Bytes > 0) or (res <> FT_OK); // or timeout
if res <> FT_OK then exit;
i := Read_USB_Device_Buffer(FT_Q_Bytes);
j := 0;
Done := False;
  repeat
  if (FT_In_Buffer[j] = $FA) then
    begin
    if (j < (i-2)) then
      begin
      if (FT_In_Buffer[j+1] = $AA) then Done := true;
      end;
    end;
  j := j + 1;
  until (j=i) or Done;
OutIndex := 0;
AddToBuffer($AB); // bad command
SendBytes(OutIndex);
  repeat
  res := Get_USB_Device_QueueStatus;
  until (FT_Q_Bytes > 0) or (res <> FT_OK); // or timeout
if res <> FT_OK then exit;
i := Read_USB_Device_Buffer(FT_Q_Bytes);
j := 0;
Done := False;
  repeat
  if (FT_In_Buffer[j] = $FA) then
    begin
    if (j <= (i-2)) then
      begin
      if (FT_In_Buffer[j+1] = $AB) then Done := true;
      end;
    end;
  j := j + 1;
  until (j=i) or Done;

if Done then Sync_To_MPSSE := true;
end;

function InitDev : boolean;
var passed : boolean;
res : FT_Result;
begin
res := Set_USB_Device_LatencyTimer(16);
res := Set_USB_Device_BitMode($00,$00); // reset controller
res := Set_USB_Device_BitMode($00,$08); // enable Host Bus Emulation
passed := Sync_To_MPSSE;
InitDev := passed;
end;

procedure TForm1.ComboBox1DropDown(Sender: TObject);
begin
GetNames;
end;


procedure showdata(rcvddata : integer);
var CharH,CharL : Char;
i : integer;
begin
inc(memolines);
if memolines > 2000 then
  begin
  form1.Memo1.Clear;
  form1.Memo1.Update;
  memolines := 0;
  end;
i := RcvdData AND $FF;
if (i > $2F) AND (i <$7F) then
  begin
  CharL := chr(i);
  end
else
  begin
  CharL := '.';
  end;
form1.Memo1.Lines.Append('$'+HexBytetostr(RcvdData)+' '+CharH+CharL);
end;

//====================================================
//== routines to use in host emulation
//====================================================

procedure GetData;
var res : FT_Result;
 j,i : integer;
begin
j := 0;
i := 0;
// assume at least 1 byte
repeat
  res := Get_USB_Device_QueueStatus;
  if FT_Q_Bytes > 0 then
    begin
    j := Read_USB_Device_Buffer(FT_Q_Bytes);
    end
  else
    begin
    sleep(0); // delay for XP systems that lock up
    end;
until (j > 0) or (res <> FT_OK);
if res = FT_OK then
  begin
  repeat
    ShowData(FT_In_Buffer[i]);
    inc(i);
  until i = j;
  end;
end;


procedure SndImmediate;
begin
OutIndex := 0;
AddToBuffer($87); // Send Immediate
SendBytes(OutIndex); // send off the command
end;

procedure Write_Short_Add(Addlow,DataB : byte);
begin
inc(memolines);
if memolines > 2000 then
  begin
  form1.Memo1.Clear;
  form1.Memo1.Update;
  memolines := 0;
  end;
form1.Memo1.Lines.Append('Write $'+HexBytetostr(DataB)+
 ' to $'+HexBytetostr(Addlow) );
AddToBuffer($92); // write short
AddToBuffer(Addlow); // Address low
AddToBuffer(DataB); // Data
SendBytes(OutIndex); // send off the command
end;

procedure Write_Ext_Add(Addhigh,Addlow,DataB : byte);
begin
inc(memolines);
if memolines > 2000 then
  begin
  form1.Memo1.Clear;
  form1.Memo1.Update;
  memolines := 0;
  end;
form1.Memo1.Lines.Append('Write $'+HexBytetostr(DataB)+
' to $'+HexBytetostr(AddHigh)+HexBytetostr(Addlow) );
AddToBuffer($93); // write extended
AddToBuffer(Addhigh); // Address high
AddToBuffer(Addlow); // Address low
AddToBuffer(DataB); // Data
SendBytes(OutIndex); // send off the command
end;

procedure Read_Short_Add(Addlow : byte);
begin
inc(memolines);
if memolines > 2000 then
  begin
  form1.Memo1.Clear;
  form1.Memo1.Update;
  memolines := 0;
  end;
form1.Memo1.Lines.Append('Read from $'+HexBytetostr(Addlow) );
AddToBuffer($90); // read short
AddToBuffer(Addlow); // Address low
AddToBuffer($87); // Send Immediate
SendBytes(OutIndex); // send off the command
GetData;
end;

procedure Read_Ext_Add(Addhigh,Addlow : byte);
begin
inc(memolines);
if memolines > 2000 then
  begin
  form1.Memo1.Clear;
  form1.Memo1.Update;
  memolines := 0;
  end;
form1.Memo1.Lines.Append('Read from $'+HexBytetostr(AddHigh)+
HexBytetostr(Addlow) );
AddToBuffer($91); // read extended
AddToBuffer(Addhigh); // Address high
AddToBuffer(Addlow); // Address low
AddToBuffer($87); // Send Immediate
SendBytes(OutIndex); // send off the command
GetData;
end;

procedure WaitOnHigh;
begin
inc(memolines);
if memolines > 2000 then
  begin
  form1.Memo1.Clear;
  form1.Memo1.Update;
  memolines := 0;
  end;
form1.Memo1.Lines.Append('Wait on I/O 1 High');
AddToBuffer($88);
SendBytes(OutIndex); // send off the command
end;

procedure WaitOnLow;
begin
inc(memolines);
if memolines > 2000 then
  begin
  form1.Memo1.Clear;
  form1.Memo1.Update;
  memolines := 0;
  end;
form1.Memo1.Lines.Append('Wait on I/O 1 Low');
AddToBuffer($89);
SendBytes(OutIndex); // send off the command
end;

procedure Read_IOs;
begin
inc(memolines);
if memolines > 2000 then
  begin
  form1.Memo1.Clear;
  form1.Memo1.Update;
  memolines := 0;
  end;
form1.Memo1.Lines.Append('Read from I/Os');
AddToBuffer($83); // Read high byte
SendBytes(OutIndex); // send off the command
GetData;
end;

procedure Write_IOs;
var Valb,Dirb : byte;
begin
inc(memolines);
if memolines > 2000 then
  begin
  form1.Memo1.Clear;
  form1.Memo1.Update;
  memolines := 0;
  end;
Valb := 0;
Dirb := 0;
if form1.CheckBox3.Checked then Dirb := Dirb or $01;
if form1.CheckBox5.Checked then Dirb := Dirb or $02;
if form1.CheckBox4.Checked then Valb := Valb or $01;
if form1.CheckBox6.Checked then Valb := Valb or $02;
form1.Memo1.Lines.Append('Writing I/Os');
AddToBuffer($82); // Set high byte
AddToBuffer(Valb); // Value
AddToBuffer(Dirb); // Direction
SendBytes(OutIndex); // send off the command
end;

//====================================================
//====================================================

function NibbleToHex(charStr : string) : byte;
var tmpint : byte;
nibbleStr : String;
begin
tmpint := 0;
if CharStr = '0' then tmpint := 0;
if CharStr =  '1' then tmpint := 1;
if CharStr =  '2' then tmpint := 2;
if CharStr =  '3' then tmpint := 3;
if CharStr =  '4' then tmpint := 4;
if CharStr =  '5' then tmpint := 5;
if CharStr =  '6' then tmpint := 6;
if CharStr =  '7' then tmpint := 7;
if CharStr =  '8' then tmpint := 8;
if CharStr =  '9' then tmpint := 9;
if CharStr =  'A' then tmpint := 10;
if CharStr =  'B' then tmpint := 11;
if CharStr =  'C' then tmpint := 12;
if CharStr =  'D' then tmpint := 13;
if CharStr =  'E' then tmpint := 14;
if CharStr =  'F' then tmpint := 15;
if CharStr =  'a' then tmpint := 10;
if CharStr =  'b' then tmpint := 11;
if CharStr =  'c' then tmpint := 12;
if CharStr =  'd' then tmpint := 13;
if CharStr =  'e' then tmpint := 14;
if CharStr =  'f' then tmpint := 15;
NibbleToHex := tmpint;

end;

function StrToHex(c4harStr : String) : word;
var tmpint,I,J : integer;
nibbleStr : String;
begin
tmpint := 0;
I := Length(c4harStr);
J := 0;
repeat
  nibbleStr := C4harStr[J+1];
  tmpint := (tmpint*16) + NibbleToHex(nibbleStr);
  J := J + 1;
until J = I;
StrToHex := tmpint;
end;

procedure DisableButtons;
begin
form1.Button1.Enabled := true;
form1.Button2.Enabled := false;
form1.Button3.Enabled := false;
form1.Button4.Enabled := false;
form1.Button5.Enabled := false;
form1.Button6.Enabled := false;
form1.Button7.Enabled := false;
form1.Button8.Enabled := false;
form1.Button9.Enabled := false;
end;

procedure EnableButtons;
begin
form1.Button1.Enabled := false;
form1.Button2.Enabled := true;
form1.Button3.Enabled := true;
form1.Button4.Enabled := true;
form1.Button5.Enabled := true;
form1.Button6.Enabled := true;
form1.Button7.Enabled := true;
form1.Button8.Enabled := true;
form1.Button9.Enabled := true;
form1.GroupBox1.Enabled := true;
form1.GroupBox2.Enabled := true;
form1.GroupBox3.Enabled := true;
form1.GroupBox4.Enabled := true;
end;

procedure TForm1.Button1Click(Sender: TObject);
var Dname : string;
passed : boolean;
begin
Form1.Button1.Enabled := false;
Form1.Button2.Enabled := false;
DName := form1.ComboBox1.Text;
if (Dname <> '') then
  begin
  passed := OpenPort(Dname);
  if passed then
    begin
    form1.Memo1.Lines.Add('Opened Device ' + Dname);
    passed := InitDev;
    if  passed then
      begin
      form1.Memo1.Lines.Add('Initialisation passed');
      EnableButtons;
      end
    else
      begin
      form1.Memo1.Lines.Add('Initialisation failed, closing port');
      closeport;
      DisableButtons;
      end;
    end
  else
    begin
    form1.Memo1.Lines.Add('Error : open failed for : '+Dname);
    DisableButtons;
    end;
  end
else
  begin
  form1.Memo1.Lines.Add('Error : You must select a device');
  Form1.Button1.Enabled := true;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
closeport;
form1.Memo1.Lines.Add('Port Closed');
DisableButtons;
end;


procedure TForm1.Button3Click(Sender: TObject);
var AddLow : byte;
begin
DisableButtons;
repeat
  Addlow := StrToHex(Form1.Edit2.text) AND $FF;
  Read_Short_Add(Addlow);
  application.ProcessMessages;
until NOT Form1.CheckBox1.Checked ;
EnableButtons;
end;

procedure TForm1.Button5Click(Sender: TObject);
var AddLow, DataB : byte;
begin
DisableButtons;
repeat
  Addlow := StrToHex(Form1.Edit4.text) AND $FF;
  DataB := StrToHex(Form1.Edit5.text) AND $FF;
  Write_Short_Add(Addlow,DataB);
  application.ProcessMessages;
until NOT Form1.CheckBox2.Checked;
EnableButtons;
end;

procedure TForm1.Button4Click(Sender: TObject);
var AddLow,AddHigh : byte;
begin
DisableButtons;
repeat
  AddHigh := StrToHex(Form1.Edit1.text) AND $FF;
  Addlow := StrToHex(Form1.Edit2.text) AND $FF;
  Read_Ext_Add(AddHigh,Addlow);
  application.ProcessMessages;
until NOT Form1.CheckBox1.Checked  ;
EnableButtons;
end;

procedure TForm1.Button6Click(Sender: TObject);
var AddLow,AddHigh, DataB : byte;
begin
DisableButtons;
repeat
  Addhigh := StrToHex(Form1.Edit3.text) AND $FF;
  Addlow := StrToHex(Form1.Edit4.text) AND $FF;
  DataB := StrToHex(Form1.Edit5.text) AND $FF;
  Write_Ext_Add(AddHigh,Addlow,DataB);
  application.ProcessMessages;
until NOT Form1.CheckBox2.Checked;
EnableButtons;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
DisableButtons;
Read_IOs;
EnableButtons;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
DisableButtons;
Write_IOs;
EnableButtons;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
DisableButtons;
Write_IOs;
EnableButtons;
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
DisableButtons;
Write_IOs;
EnableButtons;
end;

procedure TForm1.CheckBox6Click(Sender: TObject);
begin
DisableButtons;
Write_IOs;
EnableButtons;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
DisableButtons;
WaitOnHigh;
EnableButtons;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
DisableButtons;
WaitOnLow;
EnableButtons;
end;

end.
